from Products.CMFCore.utils import getToolByName


def installActions(portal, out, actions, provider='portal_actions'):

    """
    Install actions to given provider.
    """
    
    for action in actions:
        installAction(portal, out, action[0], action[1], action[2],
                      action[3], action[4], action[5], provider)


def installAction(portal, out, id, name, action, condition, permission, category,
                  provider='portal_actions'):

    actionstool = getToolByName(portal, provider)

    actionInfos = actionstool.listActions()
    actions = ()
    
    for a in actionInfos:
      actions += a.id,

    if id not in actions:
      print >> out, "Adding action %s category %s" % (id, category)
      actionstool.addAction(id, name=name, action=action, 
        condition=condition, permission=permission, category=category)


def hideActions(self, out, provider, actionIds=[], category=None):
    
    """ Hide the action listed
    """
    
    actionstool = getToolByName(self, provider)
    actionInfos = actionstool.listActions()
    actions = ()
    
    for a in actionInfos:
      if a.id in actionIds:
          if category:
              if a.category == category:
                  print >> out, "hiding action %s for provider %s" % (a.id, provider)
                  a.visible = False
          else:
              print >> out, "hiding action %s for provider %s" % (a.id, provider)
              a.visible = False
            