from Products.StandardCacheManagers.AcceleratedHTTPCacheManager import AcceleratedHTTPCacheManager
from Products.StandardCacheManagers.RAMCacheManager import RAMCacheManager


def installHTTPCache(self, out, id, label, anonymous_only=1, interval=3600, notify_urls=()):

  """
  Install some HTTP cache
  """
  
  print >> out, "Installing HTTP cache: %s" % label

  if id not in self.objectIds():

    self._setObject(id, AcceleratedHTTPCacheManager(id))
    cache_settings={'anonymous_only' : anonymous_only,  'notify_urls' : notify_urls, 'interval' : interval } 
    
    obj = getattr(self, id)
    obj.manage_editProps(label, settings=cache_settings)

  print >> out, "done."
  
  
def installRAMCache(self, out, id, label, threshold=1000, cleanup_interval=300, request_vars=('AUTHENTICATED_USER',), max_age=3600):
  
  """
  Install some RAM cache
  """
  
  print >> out, "Installing RAM cache: %s" % label

  if id not in self.objectIds():
    
    self._setObject(id, RAMCacheManager(id))
    cache_settings={'threshold' : threshold,  'cleanup_interval' : cleanup_interval, 'request_vars' : request_vars, 'max_age' : max_age } 
    
    obj = getattr(self, id)
    obj.manage_editProps(label, settings=cache_settings)
    
  print >> out, "done."





