from Products.CMFCore.utils import getToolByName
from Products.Archetypes.debug import deprecated
from OFS.PropertyManager import PropertyManager


def install_member_properties(portal, out, memberData_properties=()):
    deprecated("This method is deprecated. Please use installMemberProperties",
         level=2)

    installMemberProperties(portal, out, memberData_properties)


def installMemberProperties(portal, out, props=()):

    """
    Install properties into member data.
    """
    
    print >> out, "Installing member properties"
    
    mdtool = getToolByName(portal, 'portal_memberdata')

    installPropertiesToObject(portal, out, mdtool, props)
    
    print >> out, "Successfully installed member properties."


def install_global_properties(portal, out, props, properties_id, properties_title):

    deprecated("This method is deprecated. Please use installPropertiesSheet",
         level=2)

    installPropertiesSheet(portal, out, props, properties_id, properties_title)


def installPropertiesSheet(portal, out, properties, properties_id, properties_title):
  
    """
    Install a properties sheet into portal_properties, and
    add all properties in the properties argument. This should
    be a list of tuples, each tuple being ('property name', 'type', 'value').
    """
    
    print >> out, "Installing properties"
    
    # install global properties sheet
    #
    if not hasattr(portal.portal_properties, properties_id):
      portal.portal_properties.addPropertySheet(properties_id, properties_title)
        
    sheet = getattr(portal.portal_properties, properties_id)

    installPropertiesToObject(portal, out, sheet, properties)


def installPropertiesToObject(portal, out, obj, props=(), create=True):
    
    """
    Install given properties to properties tab, overriding if
    necessary, or adding. The props argument should be a list
    of tuples, each tuple being ('property name', 'type', 'value', 'append', force).
    """

    # check for obj being PropertyManager
    #
    if not isinstance(obj, PropertyManager):
        print >> out, "Object is not a PropertyManager"
        return
    
    print >> out, "Setting properties on object %s" % obj.getId()
      
    # Set existing properties, or create new ones.
    #
    for p in props:
        
        prop = p[0]
        tp = p[1]
        val = p[2]
        append = (len(p) >= 4) and p[3] or 0
        #NOTE: should we by default force the override??
        force = (len(p) >= 5) and p[4] or 0

        if not obj.hasProperty(prop) and create:
            if append:
                curVal = obj.getProperty(prop)
                obj._setProperty(prop, list(curVal) + list(val))
            else:
                obj._setProperty(prop, val, tp)
        elif force:
            if append:
                curVal = obj.getProperty(prop)
                obj._setPropValue(prop, list(curVal) + list(val))
            else:
                obj._setPropValue(prop, val)
