from Products.CMFCore.utils import getToolByName


def installSetAddableTypesForObject(portal, type, out, types=[] ):
    
    """
    Set the addable types on the given object. types argument shoud be
    a list of portal_type names. This method is safest used last in your
    install script, to make sure you can actually create your portal structure.
    """
    
    if hasattr(type, 'portal_type'):
        type = type.portal_type
    
    print >> out, "Setting type info for %s" % type

    typetool = getToolByName(portal, 'portal_types')
    info = typetool.getTypeInfo(type)
    
    if not info:
        print >> out, "Couldn't find info for %s" % type
        return
    
    info._setPropValue('filter_content_types', 1)
    info._setPropValue('allowed_content_types', types)


def installUnsetFilterForObject(portal, type, out ):
    
    """
    Utility method to unset the filter on addable types. You'll need this
    for temporarily opening up some object install time to add content.
    """

    typetool = getToolByName(portal, 'portal_types')
    info = typetool.getTypeInfo(type.portal_type)
    
    if not info:
        print >> out, "Couldn't find info for %s" % type.portal_type
        return
    
    info._setPropValue('filter_content_types', 0)
    