from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews


def installSkin(portal, out, globals, skin_id, pos=-1):

    """
    Install a skin, and make sure it ends at the specified position in
    the portal_skins properties, so that it's easy to override
    existing skin elements with your product.
    """
    
    skins_tool = getToolByName(portal, 'portal_skins')

    if skin_id not in skins_tool.objectIds():
        addDirectoryViews(skins_tool, 'skins', globals)
        out.write("Added %s directory view to portal_skins\n" % skin_id)

    skins = skins_tool.getSkinSelections()
    for skin in skins:
        path = skins_tool.getSkinPath(skin)
        path = [p.strip() for p in path.split(',') if p]
        if skin_id in path:
            path.remove(skin_id)
        if path:
            path.insert(min(pos, len(path)), skin_id)
        else:
            path.insert(0, skin_id)
        skins_tool.addSkinSelection(skin, ','.join(path))
        
    print >> out, 'Installed skin'
