from Products.CMFCore.utils import getToolByName


def installWorkflows(portal, out, wfs={}, updateRoleMappings=False):

    """
    Installs workflows. the wfs argument should be a map, where each
    entry is: 'workflow_id': ('workflow_title'>,('type1', 'type2', ...))
    """

    print >> out, "Installing workflows..."
        
    wf_tool = getToolByName(portal, 'portal_workflow')
    existing_wfs = wf_tool.objectIds()

    for wf in wfs:
        if not wf in existing_wfs:
            print >> out, '  -> Adding %s' % wf
            wf_tool.manage_addWorkflow('%s (%s)' % (wf, wfs[wf][0]), wf)
        print >> out, '  -> Assigning types to %s' % wf
        wf_tool.setChainForPortalTypes(wfs[wf][1], wf)

    if updateRoleMappings:
        wf_tool.updateRoleMappings()
    
    print >> out, "done."
